﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using Syncfusion.XForms.Buttons;
using Xamarin.Forms;

namespace FactPDA
{
    class CustomGrid : Grid
    {
    }

    public class CustomStackLayout : StackLayout
    {
        public static readonly BindableProperty SelectedCountProperty = BindableProperty.Create(
            "SelectedCount", typeof(string), typeof(CustomStackLayout), string.Empty, BindingMode.Default, null, null);
        
        public static readonly BindableProperty SelectedItemsProperty = BindableProperty.Create(
            "SelectedItems", typeof(ObservableCollection<SfButton>), typeof(CustomStackLayout), null, BindingMode.Default, null, null);

       

        public CustomStackLayout()
        {
            SelectedItems = new ObservableCollection<SfButton>();
        }

        public string SelectedCount
        {
            get { return (string)GetValue(SelectedCountProperty); }
            set { this.SetValue(SelectedCountProperty, value); }
        }

        public ObservableCollection<SfButton> SelectedItems
        {
            get { return (ObservableCollection<SfButton>)GetValue(SelectedItemsProperty); }
            set { this.SetValue(SelectedItemsProperty, value); }
        }

        int selectedValue = 0;
        protected override void OnChildAdded(Element child)
        {
            if (!string.IsNullOrEmpty(SelectedCount))
            {
                if (selectedValue < int.Parse(SelectedCount))
                {
                    var button = child as SfButton;
                    button.IsChecked = true;
                    selectedValue++;
                    SelectedItems.Add(button);
                }
            }
            base.OnChildAdded(child);
        }
    }
}
