﻿namespace FactPDA.Models
{
    /// <summary>
    /// 발주조회
    /// </summary>
    public class MB050100 : BaseModel
    {
        // 추가영역
        public string REQ_STDT { get; set; } // 납기일자-시작
        public string REQ_ENDT { get; set; } // 납기일자-종료
        public string PORD_NO_SQ { get; set; } // 발주번호 + 순번 (조회용)
        public string FIND_VEND_NM { get; set; } // 발주번호 + 순번 (조회용)
        public decimal JAN { get; set; } // 미출고수량
        public string CORP_CLS { get; set; } // 회사구분
        public string CORP_CLS_NM { get; set; } // 회사구분명


        // 기본영역
        public string PORD_NO { get; set; } // 발주번호
        public int PORD_SQ { get; set; } // 발주순번(B)
        public string PORD_DT { get; set; } // 발주일자
        public string PORD_CLS { get; set; } // 발주구분
        public string PORD_CLS_NM { get; set; } // 발주구분명
        public string PORD_NM { get; set; } // 발주명칭
        public string PORD_ORG_NO { get; set; } // 발주부서코드
        public string PORD_ORG_NM { get; set; } // 발주부서코드명
        public string PORD_EMP_NO { get; set; } // 발주담당
        public string PORD_EMP_NM { get; set; } // 발주담당명
        public string PORD_VEND_NO { get; set; } // 발주업체코드
        public string PORD_VEND_NM { get; set; } // 발주업체코드명
        public string VEND_REPR { get; set; } // 업체담당자
        public string DIRE_CLS { get; set; } // 직납구분 (사용금지) 
        public string DIRE_CLS_NM { get; set; } // 직납구분 (사용금지) 명
        public string DIRE_VEND_NO { get; set; } // 직납업체코드 (사용금지) 
        public string DIRE_VEND_NM { get; set; } // 직납업체코드 (사용금지) 명
        public string DIRE_ADDR { get; set; } // 직납업체주소 (사용금지) 
        public string DIRE_REPR { get; set; } // 직납업체담당자 (사용금지) 
        public string REMK { get; set; } // 비고
        public string COM_YN { get; set; } // 완료여부
        public string DEL_YN { get; set; } // 삭제여부
        public string ITEM_CD { get; set; } // 품목코드(B)
        public string ITEM_NM { get; set; } // 품목코드명
        public string ITEM_SIZE { get; set; } // 규격
        public string SUB_SIZE { get; set; } // 하위규격
        public string TEAM_CLS { get; set; } // 관리팀
        public string TEAM_CLS_NM { get; set; } // 관리팀명
        public string ITEMM_CLS { get; set; } // 제품구분
        public string ITEMM_CLS_NM { get; set; } // 제품구분명
        public string PSAG_CLS { get; set; } // 발주사급구분(B)
        public string PSAG_CLS_NM { get; set; } // 발주사급구분명
        public string PSAG_WACD { get; set; } // 사급창고코드(B)
        public string PSAG_WACD_NM { get; set; } // 사급창고코드명
        public decimal QTY { get; set; } // 수량(B)
        public decimal UPR { get; set; } // 단가(B)
        public decimal AMT { get; set; } // 금액(B)(중복)
        public string REQ_DT { get; set; } // 납품요구일자(B)
        public string REQ_POSI { get; set; } // 납품장소(B)
        public string PDIR_NO { get; set; } // (B)
        public int PDIR_SQ { get; set; } // (B)
    }
}
