﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Net.Http;

namespace FactPDA
{
    public class CodeHelp
    {
        public enum CodeHelpTypeEnum
        {
            [Description("공통코드검색")]
            GetCommonCode,

            [Description("구성원검색")]
            GetCd1400m,

            [Description("공통코드검색")]
            GetCd4000m,

            [Description("모바일라인코드(광명/서진)")]
            GetMbCd4000mLineCls,

            [Description("모바일공정코드(인쇄공정이후)")]
            GetMbCd4000mProcCd,

            [Description("모바일설비코드")]
            GetMbEqui1000m,

            /*
            [Description("편집권한목록")]
            GetPermission,

            [Description("메뉴검색")]
            GetMenus,

            [Description("모듈검색")]
            GetModules,

            [Description("화면검색")]
            GetViews,

            [Description("권한그룹검색")]
            GetRoles,

            [Description("사용자에 부여된 권한그룹목록")]
            GetRolesInUser,

            [Description("사용자에 부여되지 않은 권한그룹목록")]
            GetRolesNotInUser,

            [Description("화면에 부여된 권한그룹목록")]
            GetRolesInView,

            [Description("화면에 부여되지 않은 권한그룹목록")]
            GetRolesNotInView,

            [Description("사용자그룹에 부여된 권한그룹목록")]
            GetRolesInGroup,

            [Description("사용자그룹에 부여되지 않은 권한그룹목록")]
            GetRolesNotInGroup,

            [Description("사용자검색")]
            GetUsers,

            [Description("사용자그룹에 부여된 사용자목록")]
            GetUsersInGroup,

            [Description("사용자그룹에 부여되지 않은 사용자목록")]
            GetUsersNotInGroup,

            [Description("사용자그룹검색")]
            GetGroups,

            [Description("사용자에 부여된 사용자그룹목록")]
            GetGroupsInUser,

            [Description("사용자에 부여되지 않은 사용자그룹목록")]
            GetGroupsNotInUser,

            [Description("개발자그룹에 소속된 사용자 검색")]
            GetUsersInDevGroup,

            [Description("검수자그룹에 소속된 사용자 검색")]
            GetUsersInTftGroup,

            [Description("거래처검색")]
            GetCustomers,

            [Description("매출거래처검색")]
            GetCustomersSale,

            [Description("매입거래처검색")]
            GetCustomersPurc,

            [Description("부서별 매출거래처검색")]
            GetCustomersSaleDept,

            [Description("파트너검색")]
            GetPartners,

            [Description("벤더검색")]
            GetVendors,

            [Description("표준상품검색")]
            GetStdProducts,

            [Description("상품검색")]
            GetPrdtItem,

            [Description("MD별상품검색")]
            GetPrdtItemByMd,

            [Description("상품검색")]
            GetProducts,

            [Description("재고속성별 상품검색")]
            GetProductsByInv,

            [Description("재고상태별 상품검색")]
            GetProductsByConGrpInv,

            [Description("상세속성별 상품검색")]
            GetProductsByInvDtl,

            [Description("재고속성(위치)별 상품검색")]
            GetProductsByInvLoc,

            [Description("상품검색")]
            GetProductsBySale,

            [Description("상품분류검색")]
            GetPrdtCategory,

            [Description("분석분류검색")]
            GetPrdtAnlCategory,

            [Description("스펙분류검색")]
            GetPrdtSpecCategory,

            [Description("PDC벤더구분검색")]
            GetPrdtPdc,

            [Description("PDC벤더구분(벤더)검색")]
            GetPrdtPdcVd,

            [Description("PDC벤더구분(PL)검색")]
            GetPrdtPdcPl,

            [Description("스펙분류선택")]
            GetPrdtSpecCategoryNotInCatSpcMap,

            [Description("창고검색")]
            GetWarehouses,

            [Description("창고검색")]
            GetWarehousesFind,

            [Description("부서별 창고검색")]
            GetWarehousesDept,

            [Description("AS 창고검색")]
            GetWarehousesAs,

            [Description("사원검색")]
            GetEmployees,

            [Description("전체사원검색")]
            GetEmployeesAll,

            [Description("매입담당검색")]
            GetEmployeesPm,

            [Description("부서별 매입담당 검색")]
            GetEmployeesPmByDept,

            [Description("영업담당 검색")]
            GetEmployeesCam,

            [Description("부서별 영업담당 검색")]
            GetEmployeesCamByDept,

            [Description("물류사원 검색")]
            GetEmployeesDelv,

            [Description("사원검색(MS)")]
            GetEmployeesMs,

            [Description("사원검색(IS)")]
            GetEmployeesIs,

            [Description("부서검색")]
            GetDepartments,

            [Description("회사검색")]
            GetCompanies,

            [Description("사원별 회사검색")]
            GetCompaniesEmployee,

            [Description("최상위 프로젝트 검색")]
            GetRootProjects,

            [Description("프로젝트검색")]
            GetProjects,

            [Description("프로젝트 처리상태")]
            GetProjectStatus,

            [Description("상위공통코드검색")]
            GetCodeMstParent,

            [Description("상세공통코드검색")]
            GetCodeMst,


            [Description("상위부서검색")]
            GetUporgno,

            [Description("도메인구분")]
            GetDomainType,

            [Description("상위부서코드검색")]
            GetDeptMstParent,

            [Description("시도검색")]
            GetZipSido,

            [Description("시군구검색")]
            GetZipSigungu,

            [Description("여신기일검색")]
            GetCrlmMst,

            [Description("승인문서코드검색")]
            GetAprvDocMst,

            [Description("거래처 거래구분 검색")]
            GetTxnTpCd,

            [Description("데모/대여 검색")]
            GetRentMst,

            [Description("계약정보 검색")]
            GetContract,

            [Description("AS고객 검색")]
            GetAsUser,

            [Description("CRM문서 검색")]
            GetIfCrm,

            [Description("전자결재문서 검색")]
            GetIfElecDoc,

            [Description("전자결재문서 검색")]
            GetIfElecDocByFormtp,

            [Description("배송정책검색")]
            GetDelivPlcTp,

            [Description("배송차수검색")]
            GetDelivPlcNo,

            [Description("벤더검색")]
            GetCustVendor,

            [Description("배송기사검색")]
            GetDriverMst,

            [Description("연체자료검색")]
            GetCrdtOverdue,

            [Description("견적서상품사양")]
            GetEstPrdtSpec,

            [Description("분석카테고리(대)")]
            GetPrdtAnlL,

            [Description("분석카테고리(중)")]
            GetPrdtAnlM,

            [Description("분석카테고리(소)")]
            GetPrdtAnlS,

            [Description("본부검색")]
            GetDepartmentsUp,

            [Description("상위부서별 부서 검색")]
            GetDepartmentsUpByDept,

            [Description("결제예정일 검색")]
            GetSettDtByCrlmcd,

            [Description("입금구분(입금등록용)")]
            GetDpstTpByDpst,

            /// <summary>
            /// 조직검색
            /// </summary>
            [Description("조직검색")]
            GetCd1200m,

            /// <summary>
            /// 조직검색(트리)
            /// </summary>
            [Description("조직검색")]
            GetCd1200mv2,

            /// <summary>
            /// 구성원검색
            /// </summary>
            [Description("구성원검색")]
            GetCd1400m,

            /// <summary>
            /// 품목코드검색
            /// </summary>
            [Description("품목코드검색")]
            GetRm1000m,

            /// <summary>
            /// 품목검색
            /// </summary>
            [Description("품목검색")]
            GetRm1000mv2,

            /// <summary>
            /// 거래처검색
            /// </summary>
            [Description("거래처검색")]
            GetCd1600m,

            /// <summary>
            /// 제품검색
            /// </summary>
            [Description("제품검색")]
            GetPd1000m,

            /// <summary>
            /// 재직중인 구성원
            /// </summary>
            [Description("재직중인 구성원")]
            GetCd1400mAndCd1200m,

            /// <summary>
            /// 거래처검색
            /// </summary>
            [Description("거래처검색")]
            GetCd1600mv2,

            /// <summary>
            /// 수주검색
            /// </summary>
            [Description("수주검색")]
            GetSm3000m,

            /// <summary>
            /// 출고지시서검색
            /// </summary>
            [Description("출고지시서검색")]
            GetPd5200m,
            */

        }

        #region // Variables //////////////////////////////////////////////////
        /// <summary>
        /// 데이터가 없을 경우 등록창 열기
        /// </summary>
        public static bool isRegFormShow = false;
        /// <summary>
        /// 검색 팝업창 검색어 필수 여부
        /// </summary>
        public static bool isSearchTextRequire = false;
        #endregion

        #region FindList (드롭다운콤보용 검색)

        public static DataTable FindList(CodeHelpTypeEnum codeHelpType)
        {
            string sqlId = StringHandler.UpperToUnderBarByPattern(codeHelpType.ToString().Replace("Get", ""));
            return FindList(sqlId);
        }
        public static DataTable FindList(CodeHelpTypeEnum codeHelpType, object parameter)
        {
            string sqlId = StringHandler.UpperToUnderBarByPattern(codeHelpType.ToString().Replace("Get", ""));
            return FindList(sqlId, parameter);
        }
        public static DataTable FindList(CodeHelpTypeEnum codeHelpType, List<object> parameters)
        {
            string sqlId = StringHandler.UpperToUnderBarByPattern(codeHelpType.ToString().Replace("Get", ""));
            return FindList(sqlId, parameters);
        }

        public static DataTable FindList(CodeHelpTypeEnum codeHelpType, params string[] param)
        {
            List<object> list = new List<object>();
            foreach (var item in param)
            {
                list.Add(item);
            }
            string sqlId = StringHandler.UpperToUnderBarByPattern(codeHelpType.ToString().Replace("Get", ""));
            return FindList(sqlId, list);
        }

        public static DataTable FindList(string sqlId)
        {
            return FindList(sqlId, null);
        }
        public static DataTable FindList(string sqlId, object parameter)
        {
            if (parameter == null)
                return FindList(sqlId, null);
            else
                return FindList(sqlId, new List<object> { parameter });
        }
        public static DataTable FindListParam(string sqlId, params string[] param)
        {
            List<object> para = param.Select(item => (object)item).ToList();
            return FindList(sqlId, para);
        }
        public static DataTable FindList(string sqlId, List<object> parameters)
        {
            return GetData(sqlId, parameters);
        }

        #endregion

        #region FindData (텍스트박스 코드검색용)
        public static object FindData(string sqlId)
        {
            return FindData(sqlId, null);
        }
        public static object FindData(string sqlId, object param1)
        {
            List<object> parameters = new List<object>();
            parameters.Add(param1);
            return FindData(sqlId, parameters);
        }
        public static object FindData(string sqlId, object param1, object param2)
        {
            List<object> parameters = new List<object>();
            parameters.Add(param1);
            parameters.Add(param2);
            return FindData(sqlId, parameters);
        }
        public static object FindData(string sqlId, object param1, object param2, object param3)
        {
            List<object> parameters = new List<object>();
            parameters.Add(param1);
            parameters.Add(param2);
            parameters.Add(param3);
            return FindData(sqlId, parameters);
        }
        public static object FindData(string sqlId, object param1, object param2, object param3, object param4)
        {
            List<object> parameters = new List<object>();
            parameters.Add(param1);
            parameters.Add(param2);
            parameters.Add(param3);
            parameters.Add(param4);
            return FindData(sqlId, parameters);
        }
        public static object FindData(string sqlId, object param1, object param2, object param3, object param4, object param5)
        {
            List<object> parameters = new List<object>();
            parameters.Add(param1);
            parameters.Add(param2);
            parameters.Add(param3);
            parameters.Add(param4);
            parameters.Add(param5);
            return FindData(sqlId, parameters);
        }
        #endregion

        #region DataTable GetData(string sqlId, List<object> paramList, out int totalRows)
        public static DataTable GetData(string sqlId, List<object> paramList)
        {
            int totalRows = 0;
            return GetData(sqlId, paramList, out totalRows);
        }
        public static DataTable GetData(string sqlId, List<object> paramList, out int totalRows)
        {
            return GetData(sqlId, null, paramList, out totalRows);
        }
        public static DataTable GetData(string sqlId, DataParam param, List<object> paramList, out int totalRows)
        {
            DataResult res = null;
            totalRows = 0;
            try
            {
                res = (new CodeHelpClient()).GetData(sqlId, param, paramList);
                if (!res.IsError)
                {
                    if (res.Data != null)
                    {
                        //총건수 구하기
                        if (res.GetData(1) != null && res.GetData(1).Rows.Count > 0)
                        {
                            totalRows = Convert.ToInt32(res.GetData(1).Rows[0][0]);
                        }

                        if (res.GetData(0) != null)
                        {
                            return res.GetData(0);
                        }
                        else
                        {
                            return null;
                        }

                    }
                    else
                    {
                        return null;
                    }
                }
                else
                {
                    //MsgBox.ErrorShow(res.Message, res.ErrorObject);
                    return null;
                }
            }
            catch (Exception ex)
            {
                //MsgBox.ErrorShow(ex);
                return null;
            }
            finally
            {
                if (res != null) { res.Dispose(); res = null; }
            }
        }
        #endregion

        #region Create Parameters
        private static List<object> GetParameters(string sqlParams)
        {
            if (String.IsNullOrEmpty(sqlParams.Trim()))
                return null;

            List<object> parameters = new List<object>();
            string[] ps = sqlParams.Split(',');
            if (ps != null)
            {
                foreach (string psItem in ps)
                {
                    if (!String.IsNullOrEmpty(psItem))
                        parameters.Add(psItem.Trim());
                }
                return parameters;
            }
            else
            {
                return null;
            }
        }

        #endregion

        #region IsParameterCheck
        private static bool IsParameterCheck(List<object> parameters)
        {
            if (parameters == null)
                return false;

            bool isReturn = false;
            foreach (object val in parameters)
            {
                if (val != null && !String.IsNullOrEmpty(val.ToString()))
                {
                    isReturn = true;
                    break;
                }
            }
            return isReturn;
        }
        #endregion
    }

    public class CodeHelpClient : HttpClientInit
    {
        //웹 접근 URI
        const string webapiUri = @"api/CodeHelp";

        //----------------------------------------------------------------------------
        // HttpClient 생성 및 객체 반환
        //---------------------------------------------------------------------------- 
        public DataResult GetData(string sqlId, DataParam param, List<object> paramList)
        {
            Dictionary<string, object> OtherValue = new Dictionary<string, object>();
            OtherValue.Add("R_CORP_CD", GlobalVar.CorpCd);
            OtherValue.Add("R_EMP_NO", GlobalVar.EmpNo);
            if (param == null)
                param = new DataParam();
            param.Add("R_CORP_CD", GlobalVar.CorpCd);

            try
            {
                DataRequest request = new DataRequest()
                {
                    ServiceId = "CodeHelpBDL",
                    ProcId = "GetCodeHelpList",
                    SqlId = sqlId,
                    IsReal = GlobalVar.IsReal,
                    Param = param,
                    ParamList = paramList,
                    OtherValue = OtherValue
                };

                var jsonRequest = JsonConvert.SerializeObject(request);
                var httpContent = new StringContent(jsonRequest, System.Text.Encoding.UTF8, "application/json");
                var resp = Init().PostAsync(webapiUri, httpContent).Result;
                if (resp.IsSuccessStatusCode)
                {
                    var resultContent = resp.Content.ReadAsStringAsync().Result;
                    return JsonConvert.DeserializeObject<DataResult>(resultContent);
                }
                else
                {
                    throw new Exception(resp.StatusCode.ToString() + Environment.NewLine +
                                        resp.RequestMessage.ToString() + Environment.NewLine +
                                        resp.ReasonPhrase.ToArray());
                }
            }
            catch (Exception ex)
            {
                throw new Exception((new ErrorHandler()).GetMessage(ex));
            }
        }
    }
}
