﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Diagnostics;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace FactPDA.ViewModels
{
    /// <summary>
    /// 사용자변경
    /// </summary>
    public class UserChangeViewModel : BaseViewModel
    {
        // 리스트 데이터 선언
        public ObservableCollection<UserChange> Items { get; set; }

        // 조회 명령 선언
        public Command LoadItemsCommand { get; set; }

        // 선택값 저장
        UserChange _SelectedItem = new UserChange();
        public UserChange SelectedItem
        {
            get { return _SelectedItem; }
            set { SetProperty(ref _SelectedItem, value); }
        }

        // 생성자
        public UserChangeViewModel()
        {
            Title = "사용자변경";
            Items = new ObservableCollection<UserChange>();
            LoadItemsCommand = new Command(() => ExecuteLoadItemsCommand());
        }

        // 데이터 조회
        public void ExecuteLoadItemsCommand()
        {
            if (IsBusy)
                return;

            IsBusy = true;
            SelectedItem.IsSelected = false;
            try
            {
                Items.Clear();
                List<SendDataV2> list = new List<SendDataV2>();

                // 조회
                list.Add(new SendDataV2("USP_MB000200L10_R10", new DataTable().RowAdd()
                    .DataTableColumnInputData("R_CRUD", "R10")
                    .DataTableColumnInputData("V_CORP_CLS", SelectedItem.CORP_CLS)
                    .DataTableColumnInputData("V_EMP_NM", SelectedItem.EMP_NM)
                ));

                ReturnData rtn = DataCommon.ProcCall(list);
                if (rtn.success)
                {
                    DataTable table = rtn.data.GetData(0);
                    Items.SetDataTableModel<UserChange>(table);
                    CntDBCOUNT = table.Rows.Count;
                }
            }
            catch (Exception ex)
            {
                ErrMESSAGE = ex.Message;
            }
            finally
            {
                IsBusy = false;
            }
        }
    }
}

