﻿using FactPDA.Models;
using FactPDA.ViewModels;
using FactPOP.Win.Utils;
using System;
using System.IO;
using System.Reflection;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class BasePage : ContentPage
    {
        public enum MessageType
        {
            ReFresh,
            None
        }

        public BasePage()
        {
            InitializeComponent();
        }

        protected override void OnAppearing()
        {
            base.OnAppearing();
            InitControlAsync();
            //txtCORP_CLS_NM.Text = GlobalVar.CorpClsNm;
            txtEMP_NM.Text = GlobalVar.EmpNm;
        }
        public virtual void ReFresh()
        {
            txtEMP_NM.Text = GlobalVar.EmpNm;
        }

        public virtual void InitControlAsync()
        {
            //SetScannerAsync();
        }

        protected void ShowErrBox(Exception ex)
        {
            DisplayAlert("오류", ex.Message, "확인");
        }

        protected void ShowErrBox(string message)
        {
            DisplayAlert("오류", message, "확인");
        }

        protected void ShowMsgBox(string message, string title = "확인")
        {
            DisplayAlert(title, message, "확인");
        }

        // 공지사항
        protected void Notice_Clicked(object sender, EventArgs e)
        {
            Navigation.PushAsync(new NoticePage());
        }

        // 사용자변경
        protected void UserChange_Clicked(object sender, EventArgs e)
        {
            Navigation.PushAsync(new UserChangePage());
        }

        // Logout
        async void Logout_Clicked(object sender, EventArgs e)
        {
            var result = await DisplayAlert("확인", "로그아웃하겠습니까?", "확인", "취소");
            if (result)
            {
                //App.IsUserLoggedIn = false;
                //Navigation.InsertPageBefore(new LoginPage(), this);
                //await Navigation.PopAsync();
            }
        }
    }
}