﻿using System;
using System.Globalization;
using Xamarin.Forms;
using static FactPDA.Models.BaseModel;

namespace FactPDA.Views
{
    public class SelectBoolToColorConverterEx : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return (bool)value == true ? (Color)Application.Current.Resources["ListViewSelectedItemGridOutColor"] : Color.White;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class StatusBoolToColorConverterEx : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value is StatusObject)
            {
                StatusObject statusObject = (StatusObject)value;
                switch (statusObject)
                {
                    case StatusObject.None:
                        return Color.White;
                    case StatusObject.OK:
                        return Color.Green;
                    case StatusObject.NG:
                        return Color.Red;
                    default:
                        return Color.White;
                }
            }
            else
            {
                return Color.White;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


    public class StringToNullableIntConverterEx : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value.GetNullToEmpty();
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string strValue = value as string;

            if (string.IsNullOrEmpty(strValue))
                return null;

            int resultInt;

            if (int.TryParse(strValue, out resultInt))
            {
                return resultInt;
            }
            return 0;
        }
    }


}
