﻿using FactPDA.Models;
using FactPDA.ViewModels;
using FactPOP.Models;
using FactPOP.Win.Utils;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Plugin.Settings;
using Plugin.Settings.Abstractions;

namespace FactPDA.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class FontChangePage : ContentPage
    {
        public static string FontSize
        {
            get => CrossSettings.Current.GetValueOrDefault("SetFontSize", "");
            set => CrossSettings.Current.AddOrUpdateValue("SetFontSize", value);
        }

        public FontChangePage()
		{
			InitializeComponent ();
            InitControlAsync();
        }

        public void InitControlAsync()
        {
            try
            {
                txtFontSize.Text = Application.Current.Resources["DefaultFontSize"].ToString();
            }
            catch (Exception ex)
            {
                DisplayAlert("오류", ex.Message, "확인");
            }
        }

        protected void btnSave_Clicked(object sender, EventArgs e)
        {
            try
            {
                if (Convert.ToDouble(txtFontSize.Text) < 10)
                {
                    txtFontSize.Text = "10";
                }
                else if (Convert.ToDouble(txtFontSize.Text) > 30)
                {
                    txtFontSize.Text = "30";
                }

                FontSize = txtFontSize.Text;
                Application.Current.Resources["DefaultFontSize"] = Convert.ToDouble(txtFontSize.Text);
                Application.Current.Resources["GroupCaptionLabelFontSize"] = Convert.ToDouble(txtFontSize.Text) + 2;
                Application.Current.Resources["MiddleTitleLabelFontSize"] = Convert.ToDouble(txtFontSize.Text);

                //Navigation.InsertPageBefore(new LoginPage(), this);
                Navigation.PopAsync();
            }
            catch (Exception ex)
            {
                DisplayAlert("오류", ex.Message, "확인");
            }
        }

        private async void btnClose_Clicked(object sender, EventArgs e)
        {
            await Navigation.PopAsync();
        }
    }
}