﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using FactPDA.ViewModels;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Acr.UserDialogs;
using System.Threading.Tasks;

namespace FactPDA.Views
{
    /// <summary>
    /// 작업지시서조회
    /// </summary>
    [XamlCompilation(XamlCompilationOptions.Compile)]
    // 작업지시서조회 메인
    public partial class MB020100Page : BasePage
    {
        // 뷰모델 선언
        MB020100ViewModel viewModel;

        // 재조회
        string Runfile = "";

        // 생성자
        public MB020100Page()
        {
            InitializeComponent();

            // 뷰-뷰모델 바인딩
            BindingContext = viewModel = new MB020100ViewModel();

            // 리스트 선택 이벤트
            listView.ItemSelected += List_ItemSelected;

            // Picker 이벤트
            picLINE_CLS10.SelectedIndexChanged += PicLINE_CLS10_SelectedIndexChanged;
            picLINE_CLS20.SelectedIndexChanged += PicLINE_CLS20_SelectedIndexChanged;
            //picPROC_CD.SelectedIndexChanged += PicPROC_CD_SelectedIndexChanged;

            // 전역전달변수초기화
            GlobalVar.SelectedEMP_NO = "";
            GlobalVar.SelectedEMP_NM = "";

            // 초기값할당
            //dtePDIR_STDT.Date = DateTime.Now.AddMonths(-1).AddDays(1);
            //dtePDIR_ENDT.Date = DateTime.Now;
            dtePDIR_DT.Date = DateTime.Now;

            // 콤보초기화
            Runfile = "";
            //rdoLINE_CLS_1.IsToggled = true;
            picLINE_CLS10.SelectedIndex = 0;
            picLINE_CLS20.SelectedIndex = 0;
            //picPROC_CD.SelectedIndex = 0;

            //if (GlobalVar.CorpCls == "10")
            //    rdoLINE_CLS_1.IsToggled = true;
            //else
            //    rdoLINE_CLS_2.IsToggled = true;
        }

        // 리스트 선택
        private void List_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            viewModel.SelectedItem = listView.SelectedItem as MB020100;
            foreach (var item in viewModel.Items)
            {
                item.IsSelected = false;
            }
            // 단일선택
            viewModel.SelectedItem.IsSelected = true;
            viewModel.PDIR_NO_SQ = viewModel.SelectedItem.PDIR_NO_SQ;
            txtSelectedREMK.Value = viewModel.SelectedItem.REMK;
        }

        // 주간야간구분 이벤트
        protected void OnRadioButtonToggled(object sender, ToggledEventArgs args)
        {
            try
            {
                txtSelectedREMK.Value = "";
                //if (rdoLINE_CLS_1.IsToggled)
                //{
                //    frmLINE_CLS10.IsVisible = true;
                //    frmLINE_CLS20.IsVisible = false;
                //    picLINE_CLS10.SelectedIndex = 0;
                //    picLINE_CLS20.SelectedIndex = 0;
                //    viewModel.Items.Clear();
                //    viewModel.SelectedItem.MSECT_CD = rdoLINE_CLS_1.StyleId;
                //}
                //if (rdoLINE_CLS_2.IsToggled)
                //{
                //    frmLINE_CLS10.IsVisible = false;
                //    frmLINE_CLS20.IsVisible = true;
                //    picLINE_CLS10.SelectedIndex = 0;
                //    picLINE_CLS20.SelectedIndex = 0;
                //    viewModel.Items.Clear();
                //    viewModel.SelectedItem.MSECT_CD = rdoLINE_CLS_2.StyleId;
                //}
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 라인 팝업(광명)
        private void PicLINE_CLS10_SelectedIndexChanged(object sender, EventArgs e)
        {
            viewModel.Selected_LINE_CLS10 = picLINE_CLS10.SelectedItem as CODEHELP_CODE;
        }

        // 라인 팝업(서진)
        private void PicLINE_CLS20_SelectedIndexChanged(object sender, EventArgs e)
        {
            viewModel.Selected_LINE_CLS20 = picLINE_CLS20.SelectedItem as CODEHELP_CODE;
        }

        // 공정 팝업
        //private void PicPROC_CD_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    viewModel.Selected_PROC_CD = picPROC_CD.SelectedItem as CODEHELP_CODE;
        //}

        // 폼 콘트롤 초기화
        public override void InitControlAsync()
        {
            base.InitControlAsync();
        }

        // 화면 진입시
        protected override void OnAppearing()
        {
            base.OnAppearing();
            Runfile = "";
        }

        // 재조회
        public override void ReFresh()
        {
            base.ReFresh();
        }

        // 날짜버튼
        protected void btnDate_Clicked(object sender, EventArgs e)
        {
            try
            {
                var thisWeek = MobileUtil.ThisWeek();
                Button button = sender as Button;
                //if (button.StyleId == "btnDATE_PRV")
                //{
                //    dtePDIR_STDT.Date = DateTime.Now.AddMonths(-2).AddDays(1);
                //    dtePDIR_ENDT.Date = DateTime.Now;
                //}
                //else if (button.StyleId == "btnDATE_NOW")
                //{
                //    dtePDIR_STDT.Date = DateTime.Now.AddMonths(-1).AddDays(1);
                //    dtePDIR_ENDT.Date = DateTime.Now;
                //}
                //else if (button.StyleId == "btnDATE_NXT")
                //{
                //    dtePDIR_STDT.Date = DateTime.Now;
                //    dtePDIR_ENDT.Date = DateTime.Now.AddMonths(1).AddDays(-1);
                //}
                if (button.StyleId == "btnDATE_CLS")
                {
                    dtePDIR_DT.Date = DateTime.Now;
                    txtSelectedREMK.Value = "";
                    picLINE_CLS10.SelectedIndex = 0;
                    picLINE_CLS20.SelectedIndex = 0;
                    //picPROC_CD.SelectedIndex = 0;
                    viewModel.Items.Clear();
                    GlobalVar.SelectedEMP_NO = "";
                    GlobalVar.SelectedEMP_NM = "";
                }
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 작업자선택
        protected void btnGenProc_Clicked(object sender, EventArgs e)
        {
        }

        // 실적등록
        protected void btnSpcProc_Clicked(object sender, EventArgs e)
        {
        }

        // 불량등록
        protected void btnOthProc_Clicked(object sender, EventArgs e)
        {
            //TODO : 주석해제할것
            //if (!viewModel.SelectedItem.IsSelected)
            //{
            //    ShowErrBox("분류차수를 선택하세요");
            //    return;
            //}
            // 중복실행방지
            if (Runfile != "")
            {
                Task.Delay(1000);
                return;
            }
            Runfile = "read";
            Navigation.PushAsync(new MB020110Page(viewModel.SelectedItem));
        }

        // 자료조회
        protected async Task btnQryProc_Clicked(object sender, EventArgs e)
        {
            // 라인코드
            if (picLINE_CLS10.SelectedIndex < 0 && picLINE_CLS20.SelectedIndex < 0)
            {
                Toast.ShortMessage("라인을 선택하세요");
                return;
            }

            // 공정코드
            //if (picPROC_CD.SelectedIndex < 0)
            //{
            //    picPROC_CD.SelectedIndex = 0;
            //    //Toast.ShortMessage("공정코드를 선택하세요");
            //    //picPROC_CD.Focus();
            //    //return;
            //}

            // 초기화
            viewModel.IsDBOK = false;
            viewModel.CntDBCOUNT = 0;
            viewModel.ErrMESSAGE = "";

            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                // Picker는 연산이 안되므로
                DateTime dteWORK_DT = new DateTime(dtePDIR_DT.Date.Year, dtePDIR_DT.Date.Month, dtePDIR_DT.Date.Day);
                //DateTime dteWORK_ENDT = new DateTime(dtePDIR_ENDT.Date.Year, dtePDIR_ENDT.Date.Month, dtePDIR_ENDT.Date.Day);

                // 전달변수정리
                viewModel.SelectedItem.PDIR_DT = dteWORK_DT.ToString("yyyy-MM-dd");
                //viewModel.SelectedItem.PDIR_ENDT = dteWORK_ENDT.ToString("yyyy-MM-dd");

                var strLINE_CLS10 = picLINE_CLS10.SelectedIndex > -1 ? viewModel.Selected_LINE_CLS10.ID.GetNullToEmpty() : "";
                var strLINE_CLS20 = picLINE_CLS20.SelectedIndex > -1 ? viewModel.Selected_LINE_CLS20.ID.GetNullToEmpty() : "";

                //if (rdoLINE_CLS_1.IsToggled == true)
                //    viewModel.SelectedItem.LINE_CLS = strLINE_CLS10;
                //else
                //    viewModel.SelectedItem.LINE_CLS = strLINE_CLS20;

                ////viewModel.SelectedItem.PROC_CD = picPROC_CD.SelectedIndex > -1 ? viewModel.Selected_PROC_CD.ID.GetNullToEmpty() : "";

                //if (rdoLINE_CLS_1.IsToggled)
                //    viewModel.SelectedItem.MSECT_CD = rdoLINE_CLS_1.StyleId;
                //else
                //    viewModel.SelectedItem.MSECT_CD = rdoLINE_CLS_2.StyleId;

                // 자료조회
                using (UserDialogs.Instance.Loading("Loading..."))
                {
                    await Task.Run(() =>
                    {
                        viewModel.LoadItemsCommand.Execute(null);
                    });
                }
                if (viewModel.CntDBCOUNT == 0)
                {
                    await DisplayAlert("정보", "자료가 없습니다", "확인");
                }

            }
            catch (Exception ex)
            {
                await DisplayAlert("에러", ex.Message, "확인");
            }
            finally
            {
                IsBusy = false;
            }
        }

        // 메인메뉴
        async void btnRtnProc_Clicked(object sender, EventArgs e)
        {
            try
            {
                var result = await DisplayAlert("확인", "메인메뉴로 복귀하겠습니까?", "확인", "취소");
                if (result)
                {
                    await Navigation.PopAsync();
                    Navigation.RemovePage(this);
                }
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }
    }
}
