﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using FactPDA.ViewModels;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    /// <summary>
    /// 사용자변경
    /// </summary>
    [XamlCompilation(XamlCompilationOptions.Compile)]
    // 사용자변경 메인
    public partial class NoticePage : ContentPage
    {
        // 뷰모델 선언
        NoticeViewModel viewModel;

        // 생성자
        public NoticePage()
        {
            InitializeComponent();

            // 뷰-뷰모델 바인딩
            BindingContext = viewModel = new NoticeViewModel();
            // 리스트 선택 이벤트
            listView.ItemSelected += List_ItemSelected;

            btnQryProc_Clicked(null, null);
        }

        // 리스트 선택
        private void List_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            viewModel.SelectedItem = listView.SelectedItem as Notice;
            foreach (var item in viewModel.Items)
            {
                item.IsSelected = false;
            }
            viewModel.SelectedItem.IsSelected = true;
            // 선택값 변경
            if (viewModel.SelectedItem.IsSelected && viewModel.SelectedItem.NOTI_CONTS != "")
            {
                lblNOTI_CONT.Text = viewModel.SelectedItem.NOTI_CONTS;
            }
        }

        // 일반처리
        protected void btnGenProc_Clicked(object sender, EventArgs e)
        {
        }

        // 특수처리
        protected void btnSpcProc_Clicked(object sender, EventArgs e)
        {
        }

        // 기타처리
        protected void btnOthProc_Clicked(object sender, EventArgs e)
        {
        }

        // 자료조회
        protected void btnQryProc_Clicked(object sender, EventArgs e)
        {
            // 초기화
            viewModel.IsDBOK = false;
            viewModel.CntDBCOUNT = 0;
            viewModel.ErrMESSAGE = "";

            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                //viewModel.QryEMP_NM = qryEMP_NM.Text;
                viewModel.LoadItemsCommand.Execute(null);
                if (viewModel.CntDBCOUNT == 0)
                {
                    DisplayAlert("정보", "자료가 없습니다", "확인");
                }
                else
                {
                    lblNOTI_CONT.Text = viewModel.SelectedItem.NOTI_CONTS;
                }
            }
            catch (Exception ex)
            {
                DisplayAlert("에러", ex.Message, "확인");
            }
            finally
            {
                IsBusy = false;
            }
        }

        // 메인메뉴
        protected async Task btnRtnProc_Clicked(object sender, EventArgs e)
        {
            await Navigation.PopAsync();
        }
    }
}