﻿using FactPDA.Models;
using FactPDA.ViewModels;
using FactPOP.Models;
using FactPOP.Win.Utils;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Plugin.Settings;
using Plugin.Settings.Abstractions;

namespace FactPDA.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class SettingPage : ContentPage
    {
        public static string SetDBServer
        {
            get => CrossSettings.Current.GetValueOrDefault("SetDBServer", "REAL");
            set => CrossSettings.Current.AddOrUpdateValue("SetDBServer", value);
        }

        public static string SetWEBServer
        {
            get => CrossSettings.Current.GetValueOrDefault("SetWEBServer", "REAL");
            set => CrossSettings.Current.AddOrUpdateValue("SetWEBServer", value);
        }

        public static string SetREALIP
        {
            get => CrossSettings.Current.GetValueOrDefault("SetREALIP", "");
            set => CrossSettings.Current.AddOrUpdateValue("SetREALIP", value);
        }
        public static string SetTESTIP
        {
            get => CrossSettings.Current.GetValueOrDefault("SetTESTIP", "");
            set => CrossSettings.Current.AddOrUpdateValue("SetTESTIP", value);
        }
        public static string SetDEBUGIP
        {
            get => CrossSettings.Current.GetValueOrDefault("SetDEBUGIP", "");
            set => CrossSettings.Current.AddOrUpdateValue("SetDEBUGIP", value);
        }

        public static string FontSize
        {
            get => CrossSettings.Current.GetValueOrDefault("SetFontSize", "20");
            set => CrossSettings.Current.AddOrUpdateValue("SetFontSize", value);
        }

        public StackLayout LayPass { get { return layPass; } }
        public StackLayout LayConfig { get { return layConfig; } }
        public Entry TxtPassword { get { return txtPassword; } }
        public SettingPage()
        {
            InitializeComponent();
            InitControlAsync();
        }

        public void InitControlAsync()
        {
            try
            {
                // DB설정
                if (SetDBServer == "TEST")
                {
                    rdoCHEK_DbInfo_2.IsToggled = true;
                }
                else
                {
                    rdoCHEK_DbInfo_1.IsToggled = true;
                }


                // WEB설정
                if (SetWEBServer == "TEST")
                {
                    rdoCHEK_SevInfo_2.IsToggled = true;
                }
                else if (SetWEBServer == "DEBUG")
                {
                    rdoCHEK_SevInfo_3.IsToggled = true;
                }
                else
                {
                    rdoCHEK_SevInfo_1.IsToggled = true;
                }

                // 
                if (SetREALIP == "")
                {
                    txtRealServer.Text = GlobalVar.RealServerURI;
                }
                else
                {
                    txtRealServer.Text = SetREALIP;
                }

                // 
                if (SetTESTIP == "")
                {
                    txtTestServer.Text = GlobalVar.TestServerURI;
                }
                else
                {
                    txtTestServer.Text = SetTESTIP;
                }

                // 
                if (SetDEBUGIP == "")
                {
                    txtDebugServer.Text = GlobalVar.DebugServerURI;
                }
                else
                {
                    txtDebugServer.Text = SetDEBUGIP;
                }

                // 
                if (FontSize == "")
                {
                    txtFontSize.Text = "20";
                }
                else
                {
                    txtFontSize.Text = FontSize;
                }

                /*
                rdoCHEK_DbInfo_2.IsToggled = true;
                rdoCHEK_SevInfo_2.IsToggled = true;
                txtRealServer.Text = GlobalVar.RealServerURI;
                txtTestServer.Text = GlobalVar.TestServerURI;
                txtDebugServer.Text = GlobalVar.DebugServerURI;
                txtFontSize.Text = Application.Current.Resources["DefaultFontSize"].ToString();
                */
            }
            catch (Exception ex)
            {
                DisplayAlert("오류", ex.Message, "확인");
            }
        }

        protected void btnValiPass_Clicked(object sender, EventArgs e)
        {
            string passWord = "1000";
            /* 잘못입력한 경우 접속방법이 없음
            string passWord = string.Empty;

            List<SendDataV2> list = new List<SendDataV2>();
            list.Add(new SendDataV2("Tool_ETCINFO", new DataTable().RowAdd()
                 .DataTableColumnInputData("R_CRUD", "R10")
                 .DataTableColumnInputData("V_CLS1", "CONPASS")
                 .DataTableColumnInputData("V_CLS2", "LABEL")
                ));

            ReturnData rtn = DataCommon.ProcCall(list);
            if (rtn.success)
            {
                if (rtn.data.GetData(0) != null && rtn.data.GetData(0).Rows.Count > 0)
                {
                    passWord = rtn.data.GetData(0).Rows[0]["VAR1"].ToString();
                }
            }
            */

            if (passWord != txtPassword.Text)
            {
                DisplayAlert("오류", $"비밀번호가 잘못 되었습니다.{Environment.NewLine}확인하여 주십시오.", "확인");
                return;
            }
            else
            {
                layPass.IsVisible = false;
                layConfig.IsVisible = true;
            }
            layPass.IsVisible = false;
            layConfig.IsVisible = true;
        }

        protected void btnSave_Clicked(object sender, EventArgs e)
        {
            try
            {
                if (rdoCHEK_DbInfo_1.IsToggled)
                    GlobalVar.IsReal = rdoCHEK_DbInfo_1.StyleId;
                else if (rdoCHEK_DbInfo_2.IsToggled)
                    GlobalVar.IsReal = rdoCHEK_DbInfo_2.StyleId;

                if (rdoCHEK_SevInfo_1.IsToggled)
                    GlobalVar.WebServerMode = rdoCHEK_SevInfo_1.StyleId;
                else if (rdoCHEK_SevInfo_2.IsToggled)
                    GlobalVar.WebServerMode = rdoCHEK_SevInfo_2.StyleId;
                else if (rdoCHEK_SevInfo_3.IsToggled)
                    GlobalVar.WebServerMode = rdoCHEK_SevInfo_3.StyleId;

                GlobalVar.RealServerURI = txtRealServer.Text;
                GlobalVar.TestServerURI = txtTestServer.Text;
                GlobalVar.DebugServerURI = txtDebugServer.Text;

                if (Convert.ToDouble(txtFontSize.Text) < 10)
                {
                    txtFontSize.Text = "10";
                }
                else if (Convert.ToDouble(txtFontSize.Text) > 30)
                {
                    txtFontSize.Text = "20";
                }

                SetDBServer = GlobalVar.IsReal;
                SetWEBServer = GlobalVar.WebServerMode;
                SetREALIP = GlobalVar.RealServerURI;
                SetTESTIP = GlobalVar.TestServerURI;
                SetDEBUGIP = GlobalVar.DebugServerURI;
                FontSize = txtFontSize.Text;

                Application.Current.Resources["DefaultFontSize"] = Convert.ToDouble(txtFontSize.Text);
                Application.Current.Resources["GroupCaptionLabelFontSize"] = Convert.ToDouble(txtFontSize.Text) + 2;
                Application.Current.Resources["MiddleTitleLabelFontSize"] = Convert.ToDouble(txtFontSize.Text);

                //Navigation.InsertPageBefore(new LoginPage(), this);
                Navigation.PopAsync();
            }
            catch (Exception ex)
            {
                DisplayAlert("오류", ex.Message, "확인");
            }
        }

        private async void btnClose_Clicked(object sender, EventArgs e)
        {
            await Navigation.PopAsync();
        }
    }
}